Merge pull request #6658 from SgtCoDFish/tweak-checkhash

Tweak checkhash script
This commit is contained in:
jetstack-bot 2024-01-19 16:56:40 +00:00 committed by GitHub
commit 862cc125da
No known key found for this signature in database
GPG Key ID: B5690EEEBB952194

View File

@ -19,16 +19,36 @@ set -eu -o pipefail
# This script takes the hash of its first argument and verifies it against the
# hex hash given in its second argument
function usage_and_exit() {
echo "usage: $0 <path-to-target> <expected-hash>"
echo "or: LEARN_FILE=<path-to-learn-file> $0 <path-to-target> <old-hash>"
exit 1
}
HASH_TARGET=${1:-}
EXPECTED_HASH=${2:-}
if [[ -z $HASH_TARGET ]]; then
usage_and_exit
fi
if [[ -z $EXPECTED_HASH ]]; then
usage_and_exit
fi
SHASUM=$(./hack/util/hash.sh "$1")
# When running 'make learn-sha-tools', we don't want this script to fail.
# Instead we log what sha values are wrong, so the make.mk file can be updated.
if [ "$SHASUM" != "$2" ] && [ "${LEARN_FILE:-}" != "" ]; then
echo "s/$2/$SHASUM/g" >> "${LEARN_FILE:-}"
if [[ "$SHASUM" == "$EXPECTED_HASH" ]]; then
exit 0
fi
if [ "$SHASUM" != "$2" ]; then
echo "invalid checksum for \"$1\": wanted \"$2\" but got \"$SHASUM\""
exit 1
fi
# When running 'make learn-sha-tools', we don't want this script to fail.
# Instead we log what sha values are wrong, so the make.mk file can be updated.
if [ "${LEARN_FILE:-}" != "" ]; then
echo "s/$EXPECTED_HASH/$SHASUM/g" >> "${LEARN_FILE:-}"
exit 0
fi
echo "invalid checksum for \"$HASH_TARGET\": wanted \"$EXPECTED_HASH\" but got \"$SHASUM\""
exit 1